using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections.Specialized;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Drawing;
using Syncfusion.Styles;
using Syncfusion.Windows.Forms;

namespace GGC_Sample2005
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }

    # region * DataSource *
    private DataTable GetTable()
    {
      DataTable dt = new DataTable("Table");

      int nCols = 5;
      int nRows = 50;
      Random r = new Random();

      for (int i = 0; i < nCols; i++)
      {
        if (i == 3)
          dt.Columns.Add(new DataColumn("List", typeof(int)));//(new DataColumn("Cancel", typeof(bool)));
        else
          dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));
      }

      for (int i = 0; i < nRows; ++i)
      {
        DataRow dr = dt.NewRow();
        for (int j = 0; j < nCols; j++)
        {
          if (j == 3)
            dr[j] = r.Next(2) == 1 ? 1 : 2;
          else if(j ==1 )
              dr[j] = string.Format("row{0} col{1}", i%4, j);
          else
            dr[j] = string.Format("row{0} col{1}", i, j);
        }
        dt.Rows.Add(dr);
      }
      return dt;
    }

    # endregion

      private void Form1_Load(object sender, EventArgs e)
      {
          this.gridGroupingControl1.ShowGroupDropArea = true;

          this.gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.MultiExtended;
          this.gridGroupingControl1.TableOptions.AllowSelection = GridSelectionFlags.None;

          this.gridGroupingControl1.TableOptions.ListBoxSelectionCurrentCellOptions = GridListBoxSelectionCurrentCellOptions.None;

          DataTable dt = GetTable();
          this.gridGroupingControl1.DataSource = dt;

          this.gridGroupingControl1.ShowGroupDropArea = true;
          this.gridGroupingControl1.TableDescriptor.AllowNew = false;

          this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add("Col1");
          this.gridGroupingControl1.Table.ExpandAllGroups(); 


          this.gridGroupingControl1.TableControlCellClick += new GridTableControlCellClickEventHandler(gridGroupingControl1_TableControlCellClick);
      }

      void gridGroupingControl1_TableControlCellClick(object sender, GridTableControlCellClickEventArgs e)
      {
          GridTableCellStyleInfo style =  e.TableControl.GetTableViewStyleInfo(e.Inner.RowIndex, e.Inner.ColIndex);
          if (style.TableCellIdentity.TableCellType == GridTableCellType.GroupCaptionRowHeaderCell)
          {
              CopyGroupRecords(style.TableCellIdentity.DisplayElement);
          }
      }
      private void CopyGroupRecords(Element element)
      {
          string s = "";

          Group group = element.ParentGroup;

          foreach (Record rec in group.FilteredRecords)
          {
              GridTableDescriptor td = group.ParentTableDescriptor as GridTableDescriptor;
              for (int i = 0; i < td.VisibleColumns.Count; ++i)
              {
                  GridVisibleColumnDescriptor vcd = td.VisibleColumns[i];
                  if (i != 0)
                      s += '\t';
                  s += rec.GetValue(vcd.Name).ToString();
              }
              s += Environment.NewLine;
          }

          Clipboard.SetDataObject(new DataObject(s), true);
      }

    private void button1_Click(object sender, EventArgs e)
    {
        this.gridGroupingControl1.TableModel.CutPaste.Copy();
    }

  }

}